import pandas
import statistics as st
import math

csv_file = pandas.read_csv('edep2_tb_cool.dat', header = None, delim_whitespace = True)
csv_data_list = csv_file.values.tolist()

energy_data = []
volume_data = []
product_list = []

units = "cm" + u"\u00B3"
units2 = "GeV/" + "cm" + u"\u00B3" + "/p"

total_volume = 0

for temp in csv_data_list:
    total_volume = total_volume + temp[2]
  
for temp in csv_data_list:
   energy_data.append(temp[6])
   volume_data.append(temp[2])
 
for i in range(len(csv_data_list)):
    product_list.append((energy_data[i]*volume_data[i]))

z = []
for y in range(len(volume_data)):
    z.append((volume_data[y] * energy_data[y])/total_volume) #individual VWA (contribution)
for y in range(0,len(z)):
    csv_data_list[y].append(z[y]) #column 9 of csv_data_list

sum_of_products = math.fsum(product_list)

print("Average Energy Deposition:", st.mean(energy_data), units2)
print("")
print("Volume Weighted Average:", sum_of_products/total_volume, units2)
print("")

p = [] #individual percentages of VWA compared to the whole
for b in range(len(z)):
    p.append((z[b]*100)/(math.fsum(z)))
for b in range (0,len(p)):
    csv_data_list[b].append(p[b]) #column 10 of csv_data_list
    
csv_data_list.sort(key=lambda row: row[6], reverse=True) #sorting from greatest to least based on energy

#new lists to account for sorted csv_data_list
individual_vwa_percentage = []
sorted_energy = []
bin_number_list = []
bin_name_list = []
sorted_volume = []

for temp in csv_data_list:
    individual_vwa_percentage.append(temp[9])
    sorted_energy.append(temp[6])
    bin_number_list.append(temp[0])
    bin_name_list.append(temp[1])
    sorted_volume.append(temp[2])

percentage = float(input("Enter the desired percentage of energy deposited: "))
print("")
x = 0
iterations = 0

print("List of bins contributing to percentage entered:")
print("")

while x < percentage:
    x = x + float(individual_vwa_percentage[iterations]) #adding individual percentages
    print("Bin Number:", bin_number_list[iterations])
    print("Bin Name:", bin_name_list[iterations])
    print("Bin Volume:", sorted_volume[iterations], units)
    print("Energy Deposited:", sorted_energy[iterations], units2)
    print("Percent of whole:",float(individual_vwa_percentage[iterations]), "%")
    print("")
    iterations = iterations + 1 #going down the list (top to bottom)
    
print("The top", iterations, "bins contribute to the top", percentage, "percent of the energy deposited")
print("The error is :", x - percentage, "%")

print("")
print("Key:")
print("")
print("p -> protons")
print("error -> difference between the sum of the percentages of the", iterations, "bin(s) listed above and the desired percentage given by the user")

