import os
import sys
import hashlib

class file_data:
    #Saves file info
    def __init__(self, index, name, size, sha):
        self.index = index
        self.name = name
        self.size = size
        self.sha = sha

    #Prints file info
    def print1(self):
        print("class file_data: size =",self.size,", index =",self.index,", name =",self.name,", sha =",self.sha)

        
        
class pathfiles_list:
    def __init__(self):
        #List of all paths 
        self.path_list = []
        
        #List of all files
        self.file_list = []
        
        
    def fill(self, top_path):
        #Add the top path to list of paths
        self.path_list.append(top_path + "/")

        index = len(self.path_list)-1
        #print("index = ",index)

        #Lists all directories and files in the first directory given
        dir_contents = os.listdir(top_path)

        #print("len = ", len(dir_contents))
        #print(dir_contents)
        
        #Writes out full path of each content in directory
        for i in dir_contents:
            temp_path = top_path + "/" + i
            #print(temp_path)

            #If it is a file it prints the name of the file, and saves information about the file
            if os.path.isfile(temp_path):
                #print("file:",i)

                #Finds and saves size of file
                size = os.path.getsize(temp_path)

                #Finds Sha
                BUF_SIZE = 65536
                #md5 = hashlib.md5()
                sha1 = hashlib.sha1()
                with open(temp_path, 'rb') as f:
                    while True:
                        data = f.read(BUF_SIZE)
                        if not data:
                            break
                        #md5.update(data)
                        sha1.update(data)
                #print("MD5: {0}".format(md5.hexdigest()))
                #print("SHA1: {0}".format(sha1.hexdigest()))
                sha = "{0}".format(sha1.hexdigest())
                
                #Creates object to join all of file's attributes, then adds file to list of files
                file = file_data(index,i,size,sha)
                self.file_list.append(file)
            
            #If it is a directory print name of directory and add it to the list of paths
            elif os.path.isdir(temp_path):
                #If any of the directories are unaccessible, skip them
                try:
                    #Makes the dir function recursive so once it finds a directory in the first directory, it goes into that one and looks for files there
                    self.fill(temp_path)

                except Exception as e:
                    print(e)


    def find_duplicates(self):
        file_list = self.file_list
        for i in range(len(file_list)):
            fileI = file_list[i]
            sizeI = fileI.size
            shaI = fileI.sha

            j = i + 1
            while(j < len(file_list)):
                fileJ = file_list[j]
                sizeJ = fileJ.size

                if(sizeJ == sizeI):
                    shaJ = fileJ.sha
                    if(shaJ == shaI):
                        print("duplicate - size: ", sizeI, "sha: ", shaI, fileI.name, "and" , fileJ.name)
                        print(self.path_list[fileI.index]+fileI.name)
                        print(self.path_list[fileJ.index]+fileJ.name)
                        print(" ")
                else:
                    break
                j += 1

            

if __name__ == "__main__":
    folder = input("Enter the path of the folder you want to look into")
    #Create object, give starting path and calls function to find all files
    obj3 = pathfiles_list()
    obj3.fill(folder)

    #Sort the list of files by size
    obj3.file_list.sort(key=lambda file: file.size, reverse=True)

    #Print(self.file_list)
    for i in obj3.file_list[0:99]:
        i.print1()
    print("file list length: ", len(obj3.file_list))
    print("directory list length", len(obj3.path_list))
    obj3.find_duplicates()
